# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`external_data`](#external_data): A short summary of the purpose of this class

## Classes

### `external_data`

Configures the external_data multiplexer

#### Examples

##### 

```puppet
class { 'external_data':
  config => {
    'cache'    => {
      'name' => 'none',
    },
    'foragers' => [
      {
        'name'    => 'example',
        'options' => {
          'colour' => 'red',
        }
      }
    ]
  }
}
```

#### Parameters

The following parameters are available in the `external_data` class.

##### `config`

Data type: `Hash`

The full config as a hash

##### `puppetserver_user`

Data type: `String`

The user that should own the config file

Default value: `'pe-puppet'`

##### `confdir`

Data type: `String`

Where the config file should be created

Default value: `$settings::confdir`

##### `script_location`

Data type: `String`

Where the script should be stored

Default value: `'/opt/puppetlabs/bin/external_data.rb'`

